/*
  Designed by LinJiangHua(xempo) 2004-2006
  Copyright 2004-06 Linjianghua(xempo).
  All Rights Reserve.
*/
#define IsEmpty(xbi,dir) DirFix(xbi,p_DirFlags,dir)

bool IsInPath(XBIN *xbi,XBinDir *dir,XBinDir *chkdir)
{
long adr=0;
if(dir==NULL)return false;
if(chkdir){
  XBinDir *pdir=chkdir;
  adr=pdir->pOwn;
  while(adr!=dir->pOwn&&(adr=pdir->parDir)>0){
	if(pdir!=chkdir)CatchClose(xbi,pdir);
	pdir=DirRead(xbi,adr);
  }
  if(pdir!=chkdir)CatchClose(xbi,pdir);
}
return (adr==dir->pOwn);
}

void *ReGetDir(XBIN *pblk,XBinDir *Dir,int strmsg)
{
if(Dir){
char *pth=NULL, *pchs, *pchs2;
long adr;
XBinDir *ptdir=pblk->cDir;
if(Dir->parDir<=0)return(strmsg? (void *)catstr(p_DirFlags,Dir->name):Dir);

adr=Dir->parDir;
do{
  if(ptdir!=pblk->cDir)free(ptdir);
  ptdir=DirRead(pblk,adr);
  adr=ptdir->parDir;
  if(strmsg){
	if(pth==NULL){
		pchs=catstr(p_DirFlags,ptdir->name);
		pchs2=catstr(p_DirFlags,Dir->name);
		pth=catstr(pchs,pchs2);
		}
	else {
		pchs=catstr(p_DirFlags,ptdir->name);
		pchs2=pth; pth=catstr(pchs,pth);
		}
	free(pchs);free(pchs2);
	}
}while(adr>0);
if(strmsg){ 
	if(ptdir!=pblk->cDir)free(ptdir); 
	return pth;
	}
return ptdir;
}
return NULL;
}

void RemoveDir(XBIN *xbi,XBinDir *pDir0,XBinDir *dir,int step)
{
XBinDir *pdir;
long siz=dir->sz+xbi->DirSize;
dir->usemsg=step>0? 1:2;
dir->date=CurDate();
__write(xbi,dir,DirFlagPos,dir->pOwn);
xbi->Dircn+=step;	xbi->mdf|=1;
if(xbi->Ver){	/* no need to limit */
  if(dir->parDir){
     if(pDir0==NULL||dir->parDir!=pDir0->pOwn){
	  pdir=DirRead(xbi,dir->parDir);
	  pdir->dircnt+=step;	pdir->sz+=step*siz;
	  pdir->mdf=1;
	  DirClose(xbi,pdir);
	  }
     else { pDir0->mdf|=1;
	    pDir0->dircnt+=step; pDir0->sz+=step*siz;
		}
	 }
  else xbi->rootcn+=step;
	}
}

void DirModify(XBIN *xbi,char *oldNam,char *newNam)
{/* newNam=NULL is Del, nor Rename */
XBinDir *Dir=DirOpen(xbi,oldNam);
if(Dir){
  XBinDir *tstdir,
  *pDir0=Dir->parDir? DirRead(xbi,Dir->parDir):NULL;
  if(newNam){/* rename */
     long adr=Dir->parDir? pDir0->subDir:xbi->DirAdr;
     tstdir=DirFix(xbi,newNam,adr);
     if(tstdir){
	popMsg(BinDat[10],newNam,1);
	CatchClose(xbi,tstdir);
	}
     else if(NameCopy(Dir->name,newNam,xbi->Ver? DirNamLen:18))Dir->mdf|=1;
	  else puts(BinDat[xbinMsg]);
  }
  else {/* deldir */
    if(IsInPath(xbi,Dir,xbi->cDir))puts(usagMsg[17]);
    else {
	tstdir=IsEmpty(xbi,Dir->subDir);/* test dir empty */
	if(tstdir){ free(tstdir); puts(usagMsg[2]); }
	else RemoveDir(xbi,pDir0,Dir,-1);
	}
    }
  CatchClose(xbi,pDir0);
  CatchClose(xbi,Dir);
    }
}